import React, { Component } from "react";
import { Alert, FlatList, Image, StyleSheet, Text, View } from "react-native";
import { instructionData } from "./src/common/Services/instruction";
import {
  SCREEN_WIDTH,
  SCREEN_HEIGHT,
  VIDEO_TITLE,
  VIDEO_TITLE_HN,
  RC_BOOK,
  RC_BOOK_HN,
  WEB_REQUEST,
  ANDROID_REQUEST,
  CNG,
  CNG_HN,
} from "./src/common/Constants";
import Header from "./src/Screens/Header";
import VechicleSurveyInstruction from "./src/Screens/VechicleSurveyInstruction";
import Orientation from "../../node_modules/react-native-orientation";
import { PrimaryButton, DashedButton } from "./src/common/ThemedComponents";
import { translate } from "react-native-digitcamera/src/common/localize/i18n";
import { connect } from "react-redux";
import { TouchableOpacity } from "react-native-gesture-handler";
import Modal from "./src/common/Modal";
import Database from "../../Components/common/Database";
import reactotron from "reactotron-react-native";

const camera = require("./src/common/Image/camera.png");
const recorder = require("./src/common/Image/recorder.png");
const tick = require("./src/common/Image/tick.png");
const deleteIcon = require("./src/common/Image/deleteIcon.png");
const cameraTip = require("./src/common/Image/cameraTip.png");

let index = 0;
let isLast = false;
// Global Veriables
let instuction = [];
var Retryinstuction = [];
let realm = Database.getRealm();
var RealmData = realm.objects("SelectedLang");
var RCBCountInRetry;
class PI extends Component {
  constructor(props) {
    super(props);
    this.state = {
      title: "",
      titleHn: "",
      subTitle: "",
      subTitleHn: "",
      image: "",
      points: [],
      index: 0,
      totalSteps: "",
      staincil: "",
      imageName: "",
      show_RC_front_Button: true,
      show_RC_back_Button: true,
      addMoreRCImages: [],
      isTipModalVisible: false,
    };
  }
  componentWillUnmount() {
    this.unsubscribe();
  }
  componentDidMount() {
    this.unsubscribe = this.props.navigation.addListener("focus", () => {
      isLast = false;
      Orientation.lockToPortrait();
      //  call retry logic
      let index = 0;
      if (this.props.RetryCountData.retryCountInfo.retryCount > 0) {
        this.updateRetryInstruction();
      } else {
        // frist try
        this.callInstructionServices();
        instuction = [];
      }
    });
  }
  updateRetryInstruction = () => {
    //for checking how many RCB images are in retry
    RCBCountInRetry = this.props.RetryImageData.retryImageInfo.filter(
      (item) => {
        return item.imageName.includes("RCB");
      }
    ).length;
    if (this.props.RetryCountData.retryCountInfo.isAddNewImageData) {
      // for checking RCB is uploaded of not
      this.props.RetryImageData.retryImageInfo.filter((item) => {
        if (item.imageName.includes("RCB")) {
          this.setState({ show_RC_front_Button: true });
        }
        if (item.imageName.includes("RCB1")) {
          this.setState({ show_RC_back_Button: true });
        }
      });

      // set new data And Clear the old of retry image data only when click on retake in incorectImages.js
      Retryinstuction = this.props.RetryImageData.retryImageInfo;
      index = this.props.RetryCountData.retryCountInfo.index;
      this.props.retryImageAction();
      this.props.retryCountAction({
        retryCount: this.props.RetryCountData.retryCountInfo.retryCount,
        index: this.props.RetryCountData.retryCountInfo.index,
        isAddNewImageData: false,
      });
    }
    console.log(
      "SASASASASASA ************  ",
      JSON.stringify(Retryinstuction, null, "  ")
    );
    if (index < Retryinstuction?.length) {
      this.setState({
        title: Retryinstuction[index]?.title,
        titleHn: Retryinstuction[index]?.titleHn,

        staincil: Retryinstuction[index]?.stepStencilAssests,
        imageName: Retryinstuction[index]?.imageName,

        subTitle: Retryinstuction[index]?.subTitle,
        subTitleHn: Retryinstuction[index]?.subTitleHn,

        image: Retryinstuction[index]?.image,
        points: Retryinstuction[index]?.points,
        totalSteps: Retryinstuction?.length,
      });
    }
  };
  // update
  updateInstructionData() {
    if (index < instuction.length) {
      this.setState({
        title: instuction[index]?.stepTitle,
        titleHn: instuction[index]?.stepTitleHn,

        staincil: instuction[index]?.stepStencilAssests,
        imageName: instuction[index]?.imageName,

        subTitle: instuction[index]?.description,
        subTitleHn: instuction[index]?.descriptionHn,

        image: instuction[index]?.stepAssests,
        points: instuction[index]?.TSurveyInstructions,
        totalSteps: instuction?.length,
      });
    }
  }

  // check type of request
  instructionWebOrAndroid(activityTypeId) {
    activityTypeId = this.getActivityTypeIdIfSSL(activityTypeId);
    return activityTypeId == 6 ||
      activityTypeId == 7 ||
      activityTypeId == 8 ||
      activityTypeId == 9 ||
      activityTypeId == 10 ||
      activityTypeId == 11 ||
      activityTypeId == 15 ||
      activityTypeId == 31
      ? WEB_REQUEST
      : ANDROID_REQUEST;
  }
  // get ssl
  getActivityTypeIdIfSSL(activityTypeId) {
    if (activityTypeId == 50) {
      // Used for SSL deeplink / mapping given by Gowtham
      activityTypeId = 5;
    } else if (activityTypeId == 49) {
      activityTypeId = 26;
    } else if (activityTypeId == 51) {
      activityTypeId = 30;
    }
    return activityTypeId;
  }
  // get instruction from API
  callInstructionServices = async () => {
    if (false) {
    } else {
      let requestTypeName = this.instructionWebOrAndroid(
        this.props.route.params.activityTypeId
      );
      let requestTypeValue;
      if (requestTypeName == WEB_REQUEST) {
        requestTypeValue = 0;
      } else {
        requestTypeValue = 1;
      }
      let V_instuction = await instructionData({
        typeId: this.props.route.params.activityTypeId,
        requestValue: requestTypeValue,
      });

      V_instuction.TSurveySteps.map((item) => {
        instuction.push(item);
      });
      // One Time call from here
      this.updateInstructionData();
    }
  };
  //RC Book dashed button
  renderItem = ({ index, item }) => {
    return (
      <DashedButton
        Title={
          this.props.route?.params?.photo?.split("/")[
            this.props.route?.params?.photo?.split("/").length - 1
          ]
        }
        RightImage={deleteIcon}
        leftImage={tick}
        onDeletePress={() => {
          const newAddMoreRCImages = [...this.state.addMoreRCImages];
          newAddMoreRCImages.splice(index, 1);

          this.setState((state) => ({
            addMoreRCImages: newAddMoreRCImages,
          }));
        }}
      />
    );
  };
  // open camera
  navigateToCamera(docName) {
    this.props.navigation.navigate("Camera", {
      title: instuction[index]?.stepTitle,
      titleHn: instuction[index]?.stepTitleHn,

      stepStencilAssests: instuction[index]?.stepStencilAssests,
      DocumentImageName: instuction[index]?.imageName,

      subTitle: instuction[index]?.description,
      subTitleHn: instuction[index]?.descriptionHn,

      totalSteps: instuction?.length,
      points: instuction[index]?.TSurveyInstructions,
      image: instuction[index]?.stepAssests,
      isLast,
    });
    if (
      instuction[index]?.stepTitle == RC_BOOK ||
      instuction[index]?.stepTitleHn == RC_BOOK_HN
    ) {
      index = index;
    } else {
      index = index + 1;
    }
    this.updateInstructionData();
    return 0;
  }
  // open camera with retry
  navigateToCameraWithRetry(docName) {
    this.props.navigation.navigate("Camera", {
      title: Retryinstuction[index]?.title,
      titleHn: Retryinstuction[index]?.titleHn,

      stepStencilAssests: Retryinstuction[index]?.stepStencilAssests,
      DocumentImageName: Retryinstuction[index]?.imageName,

      subTitle: Retryinstuction[index]?.subTitle,
      subTitleHn: Retryinstuction[index]?.subTitleHn,

      totalSteps: Retryinstuction?.length,
      points: Retryinstuction[index]?.points,
      image: Retryinstuction[index]?.image,
      isLast,
    });
    if (
      Retryinstuction[index]?.stepTitle == RC_BOOK ||
      Retryinstuction[index]?.stepTitleHn == RC_BOOK_HN
    ) {
      index = index;
    } else {
      index = index + 1;
    }
    this.updateRetryInstruction();
    return 0;
  }
  // photo tip modal
  photoTipUx = () => {
    return (
      <View style={{ flex: 1, marginLeft: 24, marginRight: 24 }}>
        <View style={{ flex: 0.8 }}>
          <Image
            source={cameraTip}
            style={{
              width: SCREEN_WIDTH - 78,
              height: SCREEN_WIDTH / 2,
              resizeMode: "contain",
              marginLeft: 10,
              marginRight: 10,
            }}
          />
        </View>
        <View style={{ flex: 0.2 }}>
          <Text style={styles.tipSubText}>
            {translate(
              "Hold the phone horizontally for capturing better photos of the vehicle"
            )}
          </Text>
          <PrimaryButton
            style={{ marginTop: 24 }}
            onPress={() => {
              this.setState({ isTipModalVisible: false });
              this.navigateToCamera(this.state.imageName);
            }}
          >
            {translate("Ok, Got it")}
          </PrimaryButton>
        </View>
      </View>
    );
  };
  //Photo tip Modal
  photoTipModal = () => {
    return (
      <View>
        <Modal
          isVisible={this.state.isTipModalVisible}
          onBackdropPress={() => this.setState({ isTipModalVisible: false })}
          onClose={() => this.setState({ renewalModal: false })}
          heading={"Photo Tip"}
          isTranslate={true}
        >
          {this.photoTipUx()}
        </Modal>
      </View>
    );
  };
  render() {
    return (
      <View style={styles.main}>
        <Header
          currentStep={index}
          totalSteps={this.state.totalSteps}
          showSteps={true}
          onbackPress={() => {
            // first flow
            if (
              index < instuction.length &&
              this.props.RetryCountData.retryCountInfo.retryCount == 0 &&
              index > 0
            ) {
              index = index - 1;
              this.setState({
                title: instuction[index]?.stepTitle,
                titleHn: instuction[index]?.stepTitleHn,

                staincil: instuction[index]?.stepStencilAssests,
                imageName: instuction[index]?.imageName,

                subTitle: instuction[index]?.description,
                subTitleHn: instuction[index]?.descriptionHn,

                image: instuction[index]?.stepAssests,
                points: instuction[index]?.TSurveyInstructions,
                totalSteps: instuction?.length,
              });
            } else {
              if (index > 0) {
                index = index - 1;
                this.setState({
                  title: Retryinstuction[index]?.title,
                  titleHn: Retryinstuction[index]?.titleHn,

                  staincil: Retryinstuction[index]?.stepStencilAssests,
                  imageName: Retryinstuction[index]?.imageName,

                  subTitle: Retryinstuction[index]?.subTitle,
                  subTitleHn: Retryinstuction[index]?.subTitleHn,

                  image: Retryinstuction[index]?.image,
                  points: Retryinstuction[index]?.points,
                  totalSteps: Retryinstuction?.length,
                });
              }
            }
          }}
          onlanguagechange={() => {
            this.forceUpdate();
          }}
        ></Header>
        {/* Instructions */}
        <VechicleSurveyInstruction
          title={
            RealmData[0]?.PreferredLanguage == "en"
              ? this.state.title
              : this.state.titleHn
          }
          subTitle={
            RealmData[0]?.PreferredLanguage == "en"
              ? this.state.subTitle
              : this.state.subTitleHn
          }
          image={this.state.image}
          points={this.state.points}
          odometerReading={() => {
            reactotron.log("ODOMETER READING IN PI");
          }}
        />
        {this.photoTipModal()}
        {this.state.title == CNG || this.state.titleHn == CNG_HN ? (
          <PrimaryButton
            style={{ marginBottom: 24, marginRight: 24, marginLeft: 24 }}
            mode={"outlined"}
            color={"#FFFFFF"}
            onPress={() => {
              //show next steps and re render the data on screen
              index = index + 1;
              this.updateInstructionData();
            }}
          >
            {translate("Skip this step")}
          </PrimaryButton>
        ) : null}
        {this.state.title == RC_BOOK || this.state.titleHn == RC_BOOK_HN ? (
          <View style={{ marginLeft: 24, marginRight: 24 }}>
            <Text style={styles.rcTitle}>{translate("RC Book")}</Text>
            {/* RC front */}
            <Text style={styles.rcTypeText}>{translate("RC Front Page")}</Text>
            {!this.state.show_RC_front_Button ? (
              <DashedButton
                Title={
                  this.props.route?.params?.photo?.split("/")[
                    this.props.route?.params?.photo?.split("/").length - 1
                  ]
                }
                RightImage={deleteIcon}
                leftImage={tick}
                onDeletePress={() => {
                  this.setState({ show_RC_front_Button: true });
                }}
              />
            ) : (
              <PrimaryButton
                style={{
                  marginBottom: 24,
                  marginTop: 5,
                  backgroundColor: "white",
                  borderColor: "#00000",
                  borderWidth: 1,
                  borderRadius: 4,
                }}
                onPress={() => {
                  if (this.props.RetryCountData.retryCountInfo.retryCount > 0) {
                    if (index == Retryinstuction?.length) {
                      isLast = true;
                    }
                    this.setState({ show_RC_front_Button: false });
                  } else {
                    if (index == instuction.length) {
                      isLast = true;
                    }
                    this.setState({ show_RC_front_Button: false });
                  }
                  if (
                    this.props.RetryCountData.retryCountInfo.retryCount == 0
                  ) {
                    // for first time
                    this.navigateToCamera();
                  } else {
                    // reTry
                    this.navigateToCameraWithRetry();
                  }
                }}
                icon={({ color, size }) => {
                  return (
                    <Image source={camera} style={{ width: 30, height: 30 }} />
                  );
                }}
              >
                {translate("Capture Image")}
              </PrimaryButton>
            )}

            {/* RC back */}
            <Text style={styles.rcTypeText}>{translate("RC Back Page")}</Text>
            {!this.state.show_RC_back_Button ? (
              <DashedButton
                Title={
                  this.props.route?.params?.photo?.split("/")[
                    this.props.route?.params?.photo?.split("/").length - 1
                  ]
                }
                RightImage={deleteIcon}
                leftImage={tick}
                onDeletePress={() => {
                  this.setState({ show_RC_back_Button: true });
                }}
              />
            ) : (
              <PrimaryButton
                style={{
                  marginBottom: 24,
                  marginTop: 5,
                  backgroundColor: "white",
                  borderColor: "#00000",
                  borderWidth: 1,
                  borderRadius: 4,
                }}
                onPress={() => {
                  if (this.props.RetryCountData.retryCountInfo.retryCount > 0) {
                    if (index == Retryinstuction?.length) {
                      isLast = true;
                    }
                    this.setState({ show_RC_back_Button: false });
                  } else {
                    if (index == instuction.length) {
                      isLast = true;
                    }
                  }
                  this.setState({ show_RC_back_Button: false });
                  if (
                    this.props.RetryCountData.retryCountInfo.retryCount == 0
                  ) {
                    // for first time
                    this.navigateToCamera();
                  } else {
                    // reTry
                    this.navigateToCameraWithRetry();
                  }
                }}
                icon={({ color, size }) => {
                  return (
                    <Image source={camera} style={{ width: 30, height: 30 }} />
                  );
                }}
              >
                {translate("Capture Image")}
              </PrimaryButton>
            )}

            {/* RC back if any other */}
            <Text style={styles.rcTypeText}>
              {translate("Other RC Pages (if any)")}
            </Text>
            <FlatList
              data={this.state.addMoreRCImages}
              keyExtractor={(item, index) => index.toString()}
              renderItem={this.renderItem}
              maxToRenderPerBatch={100}
              updateCellsBatchingPeriod={1000}
            />
            <PrimaryButton
              style={{
                marginBottom: 24,
                marginTop: 5,
                backgroundColor: "white",
                borderColor: "#00000",
                borderWidth: 1,
                borderRadius: 4,
              }}
              onPress={() => {
                this.setState({
                  addMoreRCImages: [...this.state.addMoreRCImages, {}],
                });
                if (this.props.RetryCountData.retryCountInfo.retryCount > 0) {
                  if (index == Retryinstuction?.length) {
                    isLast = true;
                  }
                } else {
                  if (index == instuction.length) {
                    isLast = true;
                  }
                }
                if (this.props.RetryCountData.retryCountInfo.retryCount == 0) {
                  // for first time
                  this.navigateToCamera();
                } else {
                  // reTry
                  this.navigateToCameraWithRetry();
                }
              }}
            >
              {translate("+  Add Photos")}
            </PrimaryButton>
          </View>
        ) : null}
        {/* Button */}
        <PrimaryButton
          style={{ marginBottom: 24, marginRight: 24, marginLeft: 24 }}
          onPress={() => {
            // for first time instruction
            if (
              index < instuction.length &&
              this.props.RetryCountData.retryCountInfo.retryCount == 0
            ) {
              //for tip modal
              // visible only in frist flow
              if (index == 0) {
                this.setState({ isTipModalVisible: true });
              } else {
                this.setState({ isTipModalVisible: false });
                if (
                  this.state.title == RC_BOOK ||
                  this.state.titleHn == RC_BOOK_HN
                ) {
                  index = index + 2;
                  this.updateInstructionData();
                } else {
                  if (index == instuction.length - 1) {
                    isLast = true;
                  }
                  console.log(
                    "IS LAST >",
                    index,
                    instuction.length,
                    index == instuction.length
                  );
                  this.navigateToCamera(this.state.imageName);
                }
              }
            }

            // ReTry
            else {
              if (
                this.state.title == RC_BOOK ||
                this.state.titleHn == RC_BOOK_HN
              ) {
                index = index + RCBCountInRetry;
                this.updateRetryInstruction();
              } else {
                // if in retry and image is not RC
                if (index == Retryinstuction?.length - 1) {
                  isLast = true;
                }
                // use data in retry redux
                this.navigateToCameraWithRetry(this.state.imageName);
              }
            }
          }}
          icon={({ color, size }) => {
            return this.state.title == VIDEO_TITLE ||
              this.state.title == VIDEO_TITLE_HN ? (
              <Image source={recorder} style={{ width: 30, height: 30 }} />
            ) : (
              <Image source={camera} style={{ width: 30, height: 30 }} />
            );
          }}
          disabled={
            this.state.title == RC_BOOK || this.state.titleHn == RC_BOOK_HN
              ? !(
                  !this.state.show_RC_back_Button &&
                  !this.state.show_RC_front_Button
                )
              : false
          }
        >
          {this.state.title == VIDEO_TITLE ||
          this.state.titleHn == VIDEO_TITLE_HN
            ? translate("Capture Video")
            : this.state.title == RC_BOOK || this.state.titleHn == RC_BOOK_HN
            ? translate("Proceed")
            : translate("Capture Image")}
        </PrimaryButton>
      </View>
    );
  }
}
const styles = StyleSheet.create({
  main: {
    backgroundColor: "#FFFFFF",
    flex: 1,
  },
  rcTitle: {
    fontFamily: "Muli-Black",
    fontSize: 20,
    marginBottom: 17,
  },
  rcTypeText: {
    fontFamily: "Muli-Bold",
    fontSize: 14,
  },
  tipSubText: {
    fontFamily: "Muli-SemiBold",
    fontSize: 16,
    marginTop: 24,
    textAlign: "center",
  },
});
const mapReductStateToProps = (reduxState) => {
  const { RetryCountData, RetryImageData } = reduxState;
  return { RetryCountData, RetryImageData };
};
const mapDispatchToProps = (dispatch) => {
  return {
    retryImageAction: (data) =>
      dispatch({
        type: "CLEAR_RETRY_IMAGE_STATE",
      }),
    retryCountAction: (data) =>
      dispatch({
        type: "RETRY_COUNT",
        payload: data,
      }),
  };
};

export default connect(mapReductStateToProps, mapDispatchToProps)(PI);
