import React, { Component, useEffect, useState } from "react";
import {
  StyleSheet,
  View,
  Text,
  TouchableOpacity,
  Image,
  Button,
  LogBox,
  StatusBar,
  Linking,
} from "react-native";
import { TextInput, HelperText } from "react-native-paper";
import Colors from "../common/Colors";
import { getDocumentLast } from "../common/Services/DocumentLast";
import {
  thank_you,
  your_preins_apprvd,
  preinsp_com_will_update,
  DIRECT_PORTAL_AGENTCODE,
  super_thank_you,
  SCREEN_WIDTH,
} from "../common/Constants";
import { translate } from "react-native-digitcamera/src/common/localize/i18n";
import { PrimaryButton } from "../common/ThemedComponents";
import Orientation from "../../../react-native-orientation";
const cross = require("../common/Image/cross.png");
const thankyou_done = require("../common/Image/thankyou_done.png");
const call = require("../common/Image/call.png");
const mail = require("../common/Image/mail.png");

const ThankYou = ({ navigation, route }) => {
  const [thankYou, SetThankYou] = useState("All Done!");
  const [message, SetMessage] = useState("");
  const { activityId } = route.params;
  console.log("SDSDSD", activityId);
  useEffect(() => {
    Orientation.lockToPortrait();
    documentLast();
  }, []);

  const documentLast = async () => {
    const DocumentLastData = await getDocumentLast({
      body: {
        activityId: 1282200,
        isLast: true,
        source: "DIGITEDGE",
      },
    }).then((data) => {
      console.log(
        ":>>>>>>>>>>>>>>>>>>>>             >>>>>>>>>>>> ",
        JSON.stringify(data, null, "  ")
      );
    });
    renderMsgToScreen(DocumentLastData);
  };
  const renderMsgToScreen = (DocumentLastData) => {
    const { approved, agentCode } = DocumentLastData;
    console.log("@@@>", approved, agentCode);
    if (approved != null) {
      if (approved.toUpperCase() == "true") {
        if (agentCode == DIRECT_PORTAL_AGENTCODE) {
          SetThankYou(super_thank_you);
          SetMessage(your_preins_apprvd);
        } else {
          SetThankYou(super_thank_you);
          SetMessage(your_preins_apprvd);
        }
      } else {
        SetThankYou(thank_you);
        SetMessage(preinsp_com_will_update);
      }
    } else {
      SetThankYou(thank_you);
      SetMessage(preinsp_com_will_update);
    }
  };
  return (
    <View style={styles.main}>
      <View style={styles.subView}>
        {/* thank you msg */}
        <View style={styles.ThankYoumsgView}>
          {/* close image */}
          <TouchableOpacity onPress={() => {}}>
            <Image source={cross} style={{ height: 16, width: 16 }} />
          </TouchableOpacity>
          {/* thank you msg */}
          <View style={styles.thankyoumsg}>
            <Image
              source={thankyou_done}
              style={{
                height: 52,
                width: 60,
                marginLeft: 4,
                resizeMode: "contain",
                marginBottom: 24,
              }}
            />
            <Text style={styles.allDoneText}>{translate("All Done!")}</Text>
            <Text style={styles.PImsg}>{message}</Text>
          </View>
        </View>
        {/* need help view */}
        <View style={styles.needHelpView}>
          <Text style={styles.needHelpText}>{translate("NEED HELP?")}</Text>
          {/* mail button */}
          <TouchableOpacity
            onPress={() => {
              Linking.openURL(`mailto:${"hello@godigit.com"}`);
            }}
          >
            <View style={styles.buttonStyle}>
              <Image
                source={mail}
                style={{ width: 24, height: 24, marginLeft: 12 }}
              />
              <Text style={styles.buttonText}>{"hello@godigit.com"}</Text>
            </View>
          </TouchableOpacity>
          {/* call button */}
          <TouchableOpacity
            onPress={() => {
              Linking.openURL(`tel:${"1800 103 4448"}`);
            }}
          >
            <View style={styles.buttonStyle}>
              <Image
                source={call}
                style={{ width: 24, height: 24, marginLeft: 12 }}
              />
              <Text style={styles.buttonText}>{"1800 103 4448"}</Text>
            </View>
          </TouchableOpacity>
        </View>
      </View>
    </View>
  );
};
export default ThankYou;

const styles = StyleSheet.create({
  main: {
    flex: 1,
  },
  subView: {
    margin: 18,
    flex: 1,
  },
  ThankYoumsgView: {
    flex: 0.95,
  },
  needHelpView: {
    flex: 0.15,
  },
  thankyoumsg: {
    marginLeft: 6,
    marginRight: 6,
    marginTop: 33,
    flex: 1,
  },
  allDoneText: {
    fontFamily: "Muli-Black",
    fontSize: 20,
  },
  PImsg: {
    fontSize: 16,
    fontFamily: "Muli-SemiBold",
    marginTop: 8,
  },
  needHelpText: {
    fontFamily: "Muli-ExtraBold",
    fontSize: 12,
    color: "#999999",
  },
  buttonStyle: {
    height: 40,
    marginLeft: 6,
    marginRight: 6,
    borderColor: "#444444",
    borderWidth: 1,
    borderRadius: 4,
    marginTop: 12,
    flexDirection: "row",
    alignItems: "center",
    marginBottom: 4,
  },
  buttonText: {
    fontFamily: "Muli-Bold",
    fontSize: 16,
    marginLeft: 16,
  },
});
